#include <iostream>
#include <functional>
#include <Event.h>
#include <EventConnection.h>

void ProcessMessage(const std::string& message)
{
    std::cout << "Received: " << message << std::endl;
}

// TODO: Event tests here.

int main() {

    Event<int> cum;

    cum += [] (int i) { std::cout << i+5 << std::endl; };

    cum.Invoke(69);

    BasicEvent<std::function<void(std::string)>, std::string> OnMessage;
    BasicEvent<std::function<void()>> VoidDelegate;

    bool run = true;

    auto handler = OnMessage += [&] (const std::string& message)
    {
        std::cout << "GOTS A MESSAGE: " << message << std::endl;
    };
    auto handler2 = OnMessage += ProcessMessage;

    while (run)
    {
        std::string input;
        std::cin >> input;
        OnMessage.Invoke(input);
        VoidDelegate.Invoke();
        OnMessage(input);
        VoidDelegate();
    }


    return 0;
}

#ifdef _WIN32
extern "C" {
    int wmain(int argc, wchar_t* argv[]) {
        return main();
    }
}
#endif

